﻿using UnityEngine;
using System.Collections;


/** 
 *  This script rotates THIS gameobject to face the current location of the mouse cursor
 *  class variable 'rotate_factor' may need to be adjusted, depending on which direction the sprite faces by default
 */
public class TopDown_face_mouse : MonoBehaviour {

    private void Update()
    {
        // get mouse position and convert from SCREEN coordinates to WORLD coordinates
        Vector2 mouse_raw = Input.mousePosition;
        Vector2 mouse_world = Camera.main.ScreenToWorldPoint(mouse_raw);

        // Attept that doesn't consider 2D
        /*
        // calculate vector between mouse and THIS gameobject
        transform.LookAt(mouse_world);
        */
        LookAt2D(mouse_world);
    }

    private void LookAt2D(Vector2 p2)
    {
        float forwardAngle = 0;
        Vector2 p1 = transform.position;
        float opp = p2.y - p1.y;
        float adj = p2.x - p1.x;
        float zRadians = Mathf.Atan((p2.y - p1.y) / (p2.x - p1.x));
        if (adj < 0)
            zRadians += Mathf.PI;
        Quaternion q = Quaternion.Euler(0, 0, Mathf.Rad2Deg * zRadians);
        transform.rotation = q;
        transform.Rotate(0, 0, -forwardAngle);
    }

}
